# coding: utf-8

"""
    Crypticorn Auth API

    OpenAPI compliant REST API built using tRPC with Express

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self


class GetApiKeys200ResponseInner(BaseModel):
    """
    GetApiKeys200ResponseInner
    """  # noqa: E501

    id: StrictStr
    user_id: StrictStr
    scopes: List[StrictStr]
    name: StrictStr
    expires_at: Optional[datetime] = None
    created_at: datetime
    __properties: ClassVar[List[str]] = [
        "id",
        "user_id",
        "scopes",
        "name",
        "expires_at",
        "created_at",
    ]

    @field_validator("scopes")
    def scopes_validate_enum(cls, value):
        """Validates the enum"""
        for i in value:
            if i not in set(
                [
                    "read:hive:model",
                    "read:hive:data",
                    "write:hive:model",
                    "read:trade:bots",
                    "write:trade:bots",
                    "read:trade:api_keys",
                    "write:trade:api_keys",
                    "read:trade:orders",
                    "read:trade:actions",
                    "write:trade:actions",
                    "read:trade:exchanges",
                    "read:trade:futures",
                    "write:trade:futures",
                    "read:trade:notifications",
                    "write:trade:notifications",
                    "read:trade:strategies",
                    "write:trade:strategies",
                    "read:pay:payments",
                    "read:pay:products",
                    "write:pay:products",
                    "read:pay:now",
                    "write:pay:now",
                    "read:predictions",
                ]
            ):
                raise ValueError(
                    "each list item must be one of ('read:hive:model', 'read:hive:data', 'write:hive:model', 'read:trade:bots', 'write:trade:bots', 'read:trade:api_keys', 'write:trade:api_keys', 'read:trade:orders', 'read:trade:actions', 'write:trade:actions', 'read:trade:exchanges', 'read:trade:futures', 'write:trade:futures', 'read:trade:notifications', 'write:trade:notifications', 'read:trade:strategies', 'write:trade:strategies', 'read:pay:payments', 'read:pay:products', 'write:pay:products', 'read:pay:now', 'write:pay:now', 'read:predictions')"
                )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetApiKeys200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetApiKeys200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "user_id": obj.get("user_id"),
                "scopes": obj.get("scopes"),
                "name": obj.get("name"),
                "expires_at": obj.get("expires_at"),
                "created_at": obj.get("created_at"),
            }
        )
        return _obj
